{$APPTYPE CONSOLE}

uses windows;

const limit = 2000000000;
tests = 10;

var
  f: text;
  n, d, m, t, ans, i, cur, curans, test: longint;
  it1, it2, ifreq, ms, total_ms: int64;

function max(a, b: longint): longint;
begin
  if a > b then
    max := a
  else
    max := b;
end;

function min(a, b: longint): longint;
begin
  if a < b then
    min := a
  else
    min := b;
end;

function payment(deliveries: longint): longint;
begin
  if (deliveries = 0) or (deliveries > limit div d) then
    payment := limit
  else
    payment := deliveries * d + max(0, n - deliveries * m) * t;
end;

procedure startTiming();
begin
  QueryPerformanceCounter(it1);
end;

procedure endTiming();
begin
  QueryPerformanceCounter(it2);
  ms := round(1000 * (it2 - it1) / ifreq);
  total_ms := total_ms + ms;
end;

begin
  writeln('Please turn off antivirus software and shut down any processes that might slow down the execution time. Then press Enter.');
  readln;
  writeln('Computing...');

  assign(f, 'tmp_books.in');
  rewrite(f);
  writeln(f, 499999999, ' ', 2, ' ', 4, ' ', 2);
  close(f);

  total_ms := 0;
  QueryPerformanceFrequency(ifreq);

  for test := 1 to tests do begin

    assign(f, 'tmp_books.in');
    reset(f);
    read(f, n, d, m, t);
    close(f);

    startTiming;

    ans := payment(1);
    cur := 1;
    while true do begin
      inc(cur);
      curans := payment(cur);
      if (curans >= ans) then break;
      ans := curans;
    end;

    endTiming;

    assign(f, 'tmp_books.out');
    rewrite(f);
    writeln(f, ans);
    close(f);
  end;
  writeln;
  if (round(total_ms / tests) < 500) then
    writeln('This computer is too quick for proper testing of the BOOKS problem.')
  else begin
    writeln('The time limit for the BOOKS problem should be');
    writeln(80 + 10 * round(total_ms / tests / 3 / 10), ' milliseconds');
  end;
  readln;
end.
